package main

import (
	"flag"
	"fmt"
	"os"

	"git.teamworkapps.com/shortcut/scsusers"
	"github.com/jmoiron/sqlx"
	_ "github.com/mattn/go-sqlite3"
)
    
func main() {
    var email string
    
    flag.StringVar(&email, "email", "", "Email address to use for registration test")
    flag.Parse()

    db, err:=sqlx.Open("sqlite3", ":memory:")
    if err!=nil {
        fmt.Println("Couldn't open sqlite3 in-memory db:" + err.Error())
        os.Exit(1)
    }

    err=db.Ping()
    if err!=nil {
        fmt.Println("Couldn't ping sqlite3 in-memory db:" + err.Error())
        os.Exit(1)
    }
    schema:=`CREATE TABLE test_auth (
        id int primary key autoincrement,
        username text NOT NULL unique key 
        password text NOT NULL);`
    _ ,err=db.Exec(schema)
    if err != nil {
        fmt.Println("Schema creation failed: " + err.Error())
        os.Exit(1)
    }
    
    scsusers.Init(db, "test", "Example Test", "nobody@nowhere.com", "localhost:25")
    a:=scsusers.UsernameAvailable("testuser")
    fmt.Printf("Initial test of username available: %v\n", a)
    a=scsusers.Register("testuser", email, "127.0.0.1")
    fmt.Printf("Register returned %v\n",a)
    fmt.Printf("Attempt to log in with invalid username returned %v\n", scsusers.Login("baduser", "badpass"))
    fmt.Printf("Enter code from email:")
    var code string
    fmt.Scan(&code)
    a=scsusers.Login("testuser", code)
    fmt.Printf("Login returned %v\n",a)
    
     
}
